<template>
  <b-modal
    :visible="props.isOpen"
    scrollable
    :title="props.breed"
    no-close-on-backdrop
    no-close-on-esc
    hide-footer
    header-class="text-capitalize"
    centered
    @close="emit('close')"
  >
    <div v-if="loading" class="text-center">
      <b-spinner variant="primary" label="Text Centered"></b-spinner>
    </div>
    <template v-else-if="!err">
      <div class="image-list">
        <ImageGrid
          v-for="(dog, index) in dogSubBreeds"
          :key="`${dog.subBreed}-${index}`"
          :source="dog"
          :width="200"
          :height="200"
          is-sub-breed
          :to="`/${props.breed}/${dog.subBreed}`"
        >
          <template #title>
            <h6>{{ dog.subBreed }}</h6>
          </template>
        </ImageGrid>
      </div>

      <div v-if="!dogSubBreeds.length" class="text-center">
        <p>
          No sub breeds for this
          <span class="font-weight-bold text-capitalize">{{
            props.breed
          }}</span>
          dogs
        </p>
      </div>

      <div class="text-center mt-5">
        <span>
          See more about
          <NuxtLink :to="`/${breed}`" class="text-capitalize">
            {{ props.breed }} dogs
          </NuxtLink>
        </span>
      </div>
    </template>
    <b-alert v-else :show="!!err" variant="danger">
      {{ err }}
    </b-alert>
  </b-modal>
</template>

<script setup>
import { computed, ref, watch } from 'vue'
import { useStore } from '@nuxtjs/composition-api'

const props = defineProps({
  isOpen: {
    type: Boolean,
    default: false,
  },
  breed: {
    type: String,
    default: 'Dogs',
  },
})

const emit = defineEmits(['close'])

const store = useStore()

const dogSubBreeds = computed(() =>
  store.state.dog.dog_subBreeds.map((subBreed) => ({
    breed: props.breed,
    subBreed,
  }))
)
const loading = computed(() => store.state.dog.dog_loading)

const err = ref(null)

const fetchSubreed = async () => {
  try {
    await store.dispatch('dog/dog_fetchSubBreedList', {
      breed: props.breed,
    })
  } catch (error) {
    err.value = error
  }
}

watch(
  () => props.isOpen,
  (val) => {
    if (val) fetchSubreed()
    else {
      store.commit('dog/dog_CLEAR_SUB_BREEDS')
      err.value = null
    }
  }
)
</script>
